## zsnes 1.510%2Bbz2

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for zsnes
# 2001-2005 Aaron Lehmann <aaronl@vitelus.com>
# 2006 Joshua Kwan <joshk@triplehelix.org>
# 2007 Josh Triplett <josh@freedesktop.org>
# 2010 Michael Leuchtenburg <michael@slashhome.org>
# 2010 Etienne Millon <etienne.millon@gmail.com>
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -lpthread

%:
	dh $@ --sourcedirectory=src --with autoreconf

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=src -- \
		--enable-opengl \
		--disable-cpucheck --enable-release \
		force_arch=i486

override_dh_clean:
	rm -f src/Makefile src/cfg.h src/config.h src/config.log src/config.status src/input.h src/makefile.dep src/md.h src/parsegen src/tools/depbuild src/zsnes
	find src/ -type f -name '*.o' -delete
	dh_clean

override_dh_install:
	dh_install
	for res in 16 32 48 64; do \
		mkdir -p debian/zsnes/usr/share/icons/hicolor/$${res}x$${res}/apps; \
		cp -f src/icons/$${res}x$${res}x32.png \
			debian/zsnes/usr/share/icons/hicolor/$${res}x$${res}/apps/zsnes.png; \
	done

override_dh_installchangelogs:
	dh_installchangelogs docs/readme.txt/history.txt

override_dh_installexamples:
	mkdir -p debian/zsnes/usr/share/doc/zsnes/examples/source
	uudecode -o debian/zsnes/usr/share/doc/zsnes/examples/debian.smc.gz \
		debian/examples/debian.smc.gz.uu
	uudecode -o debian/zsnes/usr/share/doc/zsnes/examples/source/deb.set \
		debian/examples/source/deb.set.uu
	uudecode -o debian/zsnes/usr/share/doc/zsnes/examples/source/deb.map \
		debian/examples/source/deb.map.uu
	uudecode -o debian/zsnes/usr/share/doc/zsnes/examples/source/col.map \
		debian/examples/source/deb.col.uu
	cp -f debian/examples/source/debian.asm \
		debian/zsnes/usr/share/doc/zsnes/examples/source/
	cp -f debian/examples/README \
		debian/zsnes/usr/share/doc/zsnes/examples/

override_dh_installdocs:
	dh_installdocs
	# Install HTML documentation
	install -d debian/zsnes/usr/share/doc/zsnes
	cp -a docs/readme.htm debian/zsnes/usr/share/doc/zsnes/html
	rm debian/zsnes/usr/share/doc/zsnes/html/license.htm

override_dh_compress:
	dh_compress -Xdeb.set

override_dh_strip:
	dh_strip --dbgsym-migration='zsnes-dbg (<< 1.510+bz2-9~)'

## zsnes 1.510+bz2

=== src/SConstruct ===
# SConstruct file for ZSNES
# Run 'scons' in this directory to build.
# Run 'scons -c' in this directory to cleanup.

import os
env = Environment ()
platform = env['PLATFORM']

parsegen_tool = env.Program(target= 'parsegen', source = 'parsegen.cpp')

def parsegen_emitter(target,source,env):
	env.Depends(target,parsegen_tool)
	return (target,source)
	
if platform == 'posix':
	os.system('rm cfgparse.c version.o')
	print 'cfgparse.c and version.o removed'
	psrbld = Builder(action ='./parsegen -D__UNIXSDL__ $TARGET $SOURCE',
		emitter = parsegen_emitter,
		suffix = '.c', src_suffix = '.psr')

env['BUILDERS']['PARSEGEN'] = psrbld	
env.PARSEGEN('cfgparse.c', 'cfgparse.psr')

objfix_tool = env.Program(target= 'objfix.exe', source= 'objfix.c')

def objfix_emitter(target,source,env):
	env.Depends(target,objfix_tool)
	return (target,source)

objbld = Builder(action = 'objfix $TARGET',
	emitter = objfix_emitter,
	suffix = '.obj', src_suffix = '.obj')

env['BUILDERS']['OBJFIX'] = objbld

chipssrc = Split('''
	chips/c4emu.c
	chips/dsp1emu.c
	chips/dsp1proc.asm
	chips/dsp2proc.asm
	chips/dsp4emu.c
	chips/dsp4proc.asm
	chips/fxemu2.asm
	chips/fxemu2b.asm
	chips/fxemu2c.asm
	chips/fxtable.asm
	chips/sa1proc.asm
	chips/sa1regs.asm
	chips/sdd1emu.c
	chips/seta10.c
	chips/sfxproc.asm
	chips/st10proc.asm
''')
#ztcp is no longer used
netsrc = Split('''
	net/ztcp.c
''')
cpusrc = Split('''
	cpu/dma.asm
	cpu/dsp.asm
	cpu/dspproc.asm
	cpu/execute.asm
	cpu/executec.c
	cpu/irq.asm
	cpu/memory.asm
	cpu/memtable.c
	cpu/spc700.asm
	cpu/stable.asm
	cpu/table.asm
	cpu/tableb.asm
	cpu/tablec.asm
''')
dossrc = Split('''
	dos/debug.asm
	dos/joy.asm
	dos/vesa2.asm
''')
effectssrc = Split('''
	effects/burn.c
	effects/water.c
	effects/smoke.c
''')
guisrc = Split('''
	gui/gui.asm
	gui/guifuncs.c
	gui/menu.asm
''')
videosrc = Split('''
	video/makev16b.asm
	video/makev16t.asm
	video/makevid.asm
	video/mode716.asm
	video/mode716b.asm
	video/mode716d.asm
	video/mode716e.asm
	video/mode716t.asm
	video/mode7.asm
	video/mode7ext.asm
	video/mv16tms.asm
	video/newg162.asm
	video/newgfx16.asm
	video/newgfx2.asm
	video/newgfx.asm
	video/m716text.asm
	video/2xsaiw.asm
	video/procvid.asm
	video/procvidc.c
	video/sw_draw.asm
	video/hq2x16.asm
	video/hq2x32.asm
	video/hq3x16.asm
	video/hq3x32.asm
	video/hq4x16.asm
	video/hq4x32.asm
''')
zipsrc = Split('''
	zip/unzip.c
	zip/zpng.c
''')
jmasrc = Split('''
	jma/7zlzma.cpp
	jma/crc32.cpp
	jma/iiostrm.cpp
	jma/inbyte.cpp
	jma/zsnesjma.cpp
	jma/jma.cpp
	jma/lzma.cpp
	jma/lzmadec.cpp
	jma/winout.cpp
''')
basesrc = Split('''
	cfgparse.c
	cfgload.c
	endmem.asm
	init.asm
	initc.c
	uic.c
	patch.c
	ui.asm
	vcache.asm
	version.c
	zmovie.c
	zstate.c
	zloader.c
''')

linuxsrc = Split('''
	linux/copyvwin.asm
	linux/sdlintrf.asm
	linux/sdllink.c
	linux/sw_draw.c
	linux/zfilew.c
''')
winsrc = Split('''
	win/copyvwin.asm
	win/winintrf.asm
	win/winlink.cpp
	win/zfilew.c
	win/zipxw.c
''')

platform = env['PLATFORM']

# Setup environment for nasm
env.Replace (AS = 'nasm')
env.Replace (ASFLAGS = '-f elf ')

#sdl_config = Builder (action = 'sdl-config --include')

# Run config tests.
conf = Configure (env)

# Must have SDL to compile
if not conf.CheckLib ('SDL', 'SDL_Init'):
	print 'SDL not found! Please install SDL and try again.'
	Exit (1)

if not conf.CheckLib ('png'):
	print 'libpng not found! Please install libpng and try again.'
	Exit (1)

if not conf.CheckLib ('z'):
	print 'zlib not found! Please install zlib and try again.'
	Exit (1)

# Check for nasm's existence
if not conf.TryCompile ('db __NASM_VER__', '.asm'):
	print 'NASM not found! Please install NASM and try again.'
	Exit (1)

env = conf.Finish ()

# Perform any platform-specific initialization
if platform == 'posix':
	src = chipssrc  + cpusrc + dossrc + effectssrc + guisrc + videosrc + zipsrc + jmasrc + linuxsrc + basesrc
	env.Append (CCFLAGS = '-D__UNIXSDL__')
	env.Append (ASFLAGS = '-DELF -D__UNIXSDL__')
	env.Append (CCFLAGS = '-I.')
	env.Append (CCFLAGS = '-I/usr/include/SDL')

	#Build ZSNES
	env.Program('zsnes',src)

if platform == 'win32':
	if env['CC'] == 'cl':
		def freeMSVCHack(env, vclibs):
			# SCons automatically finds full versions of msvc via the registry, so
			# if it can't find 'cl', it may be because we're trying to use the
			# free version
			def isMicrosoftSDKDir(dir):
				return os.path.exists(dir+os.sep+'Include'+os.sep+'Windows.h') and os.path.exists(dir+os.sep+'Lib'+os.sep+'WinMM.lib')
 	
			def findMicrosoftSDK():
				import SCons.Platform.win32
				import SCons.Util
				import re
				if not SCons.Util.can_read_reg:
					return None
				HLM = SCons.Util.HKEY_LOCAL_MACHINE
				K = r'Software\Microsoft\.NETFramework\AssemblyFolders\PSDK Assemblies'
            		try:
                		k = SCons.Util.RegOpenKeyEx(HLM, K)
				p = SCons.Util.RegQueryValueEx(k,'')[0]
				# this should have \include at the end, so chop that off
				p = re.sub(r'(?i)\\+Include\\*$','',p)
				if isMicrosoftSDKDir(p): return p
			except SCons.Util.RegError:
		                pass
 
			K = r'SOFTWARE\Microsoft\MicrosoftSDK\InstalledSDKs'
			try:
				k = SCons.Util.RegOpenKeyEx(HLM, K)
				i=0
				while 1:
					p = SCons.Util.RegEnumKey(k,i)
					i+=1
					subk = SCons.Util.RegOpenKeyEx(k, p)
					try:
						p = SCons.Util.RegQueryValueEx(subk,'Install Dir')[0]
						# trim trailing backslashes
						p = re.sub(r'\\*$','',p)
						if isMicrosoftSDKDir(p): return p
					except SCons.Util.RegError:
						pass
			except SCons.Util.RegError:
				pass

			return None
 
		# End of local defs. Actual freeMSVCHack begins here
		if not env['MSVS'].get('VCINSTALLDIR'):
			if os.environ.get('VCToolkitInstallDir'):
				vcdir=os.environ['VCToolkitInstallDir']
				env.PrependENVPath('INCLUDE', vcdir+os.sep+'Include')
				env.PrependENVPath('LIB', vcdir+os.sep+'Lib')
				env.PrependENVPath('PATH', vcdir+os.sep+'Bin')
				env['MSVS']['VERSION'] = '7.1'
				env['MSVS']['VERSIONS'] = ['7.1']
			if not env['MSVS'].get('PLATFORMSDKDIR'):
				sdkdir = findMicrosoftSDK()
				if sdkdir:
					env.PrependENVPath('INCLUDE', sdkdir+os.sep+'Include')
					env.PrependENVPath('LIB', sdkdir+os.sep+'Lib')
					env.PrependENVPath('PATH', sdkdir+os.sep+'Bin')
					env['MSVS']['PLATFORMSDKDIR']=sdkdir
					# FREE MSVC7 only allows
					# /ML(libc) /MT(libcmt) or /MLd(libcd)
					# Full IDE versions also have
					# /MD(msvcrtd) /MTd(libcmtd) and /MDd(msvcrtd)
					# So if you want to debug with the freever, the only option is
					# the single-threaded lib, /MLd
					vclibs['Debug']='/MLd'
					vclibs['Release']='/MT'
 
		# MSVC SETUP
		# MDd is for multithreaded debug dll CRT (msvcrtd)
		# MD is for multithreaded dll CRT (msvcrt)
		# These are just my preferences
		vclibs = {'Debug':'/MDd','Release':'/MD'}
		freeMSVCHack(env, vclibs)
		
		env.Append(CCFLAGS=[vclibs[variant]])
		if debug:
			env.Append(CCFLAGS=Split('/Zi /Fd${TARGET}.pdb'))
			env.Append(LINKFLAGS = ['/DEBUG'])
			# env.Clean('.', '${TARGET}.pdb')
			# Need to clean .pdbs somehow! The above line doesn't work!
		else:
			env.Append(CCFLAGS=Split('/Og /Ot /Ob1 /Op /G6'))

			env.Append(CCFLAGS=Split('/EHsc /J /W3 /Gd'))
			env.Append(CPPDEFINES=Split('WIN32 _WINDOWS'))
		src = chipssrc + cpusrc + dossrc + effectssrc + guisrc + videosrc + zipsrc + jmasrc + winsrc
		env.Append (CCFLAGS = '-D__WIN32__')
		env.Append (ASFLAGS = '-f win32')
		
		#Build ZSNESW
		env.Program('zsnesw.exe',src)
	else:
		if debug:
			env.Append (CCFLAGS = '-g -D__WIN32__')
			env.Append (CCFLAGS = '-D__WIN32__')
			env.Append (ASFLAGS = '-f win32 -O0')
		else:
			env.Append (CCFLAGS = '-D__WIN32__')
			env.Append (CCFLAGS = '-f win32')
		
		#Build ZSNESW
		env.Program('zsnesw.exe',src)

=== debian/changelog ===
zsnes (1.510+bz2-6) unstable; urgency=low

  [ Fabian Greffrath ]
  * 0001-gcc-fno-rtti.patch: Removed, one less deviation from upstream.
  * 0002-replace_crc32.patch: Removed, not actually needed at all.
  * 0013-Fix-sound-with-libao.patch: Replace with the actual patch from
    upstream SVN.
  * 0014-Initialize-driver_format.matrix-with-NULL.patch: Only keep the
    memset() part as discussed with upstream author Nach on the ZSNES board.
  * Set Architecture: any-i386.
  * Add CPPFLAGS to CFLAGS and CXXFLAGS to enable full hardening flags.
  * fortify-source.patch: New patch to fix compilation with FORTIFY_SOURCE.
    (Closes: #698990)

  [ Etienne Millon ]
  * Fix crashes on resume : use int64s instead of floats in sem_GetTicks().
    Thanks to Ian Munsie. (Closes: #687107)
  * Fix loading states with _FORTIFY_SOURCE enabled.
    Thanks to Nelson Elhage. (Closes: #712790)
  * Add keywords to desktop file.
  * Bump Standards-Version to 3.9.4 (no changes).
  * Canonicalize VCS-* fields.

 -- Etienne Millon <etienne.millon@gmail.com>  Sat, 20 Jul 2013 12:28:28 +0200

zsnes (1.510+bz2-5) unstable; urgency=low

  * Build zsnes without libao support for wheezy.
    libao has often been a source of trouble for zsnes. Without libao support
    it will fall back to the SDL audio driver. Furthermore it will make it
    possible to install the zsnes package via multi-arch (see #638741).

 -- Fabian Greffrath <fabian+debian@greffrath.com>  Fri, 02 Nov 2012 15:07:44 +0100

zsnes (1.510+bz2-4) unstable; urgency=low

  [ Etienne Millon ]
  * Disable build on amd64 (Closes: #679526)
    - Add Multi-Arch: Foreign
  * debian/compat : use level 9 compatibility level
  * debian/rules :
    - use find -delete instead of command expansion
    - use dpkg-buildflags
    - add -Wl,--as-needed to LDFLAGS (Closes: #607311)

  [ Eshat Cakar ]
  * Improve zsnes.desktop file, thanks to Fabian Greffrath (Closes: #680054)

  [ Fabian Greffrath ]
  * Add myself to Uploaders.
  * 0001-gcc-fno-rtti.patch: Patch src/configure.in instead of the
    auto-generated src/configure.
  * Add patch to initialize the ao_sample_format structure
    (thanks also to Goswin von Brederlow - Closes: #679826)
  * Install high-res PNG icons provided with the sources (Closes: #680078)

 -- Etienne Millon <etienne.millon@gmail.com>  Fri, 06 Jul 2012 08:27:08 +0200

zsnes (1.510+bz2-3) unstable; urgency=low

  * New patches :
    - handle the nostrip build option (Closes: #438384)
    - fix FTBFS with gcc 4.7 (Closes: #667429)
    - fix audio output with libao (Closes: #470410)
  * Build-depend on libpng-dev instead of libpng12-dev (Closes: #662578)
  * Bump Standards-Version to 3.9.3 (no changes).

 -- Etienne Millon <etienne.millon@gmail.com>  Tue, 08 May 2012 15:17:42 +0200

zsnes (1.510+bz2-2) unstable; urgency=low

  * Add a patch to fix build with libpng 1.5
    (Closes: #649801, thanks to Nobuhiro Iwamatsu).
  * Enable the built-in debugger (Closes: #513201).
  * Use dh-autoreconf instead of autotools-dev.
  * Add a patch fixing hat positions not resetting properly (thanks to hakonrk
    & Simeon Maxein).
  * Add explicit dependency on libgl-dev or its implementation
    (Closes: #641277, thanks to Matthias Klose).
  * Bump Standards-Version to 3.9.2 (no changes).

 -- Etienne Millon <etienne.millon@gmail.com>  Sun, 18 Dec 2011 21:30:11 +0100

zsnes (1.510+bz2-1) unstable; urgency=low

  * Use upstream tarball (in bzip2 format) instead of a custom gzip one.
  * debian/rules: add -lpthread to LDFLAGS to fix FTBFS with new binutils
    (Closes: #620656)
  * debian/control:
    - Remove an incorrect statement about multiplayer in the description
    (Closes: #616445)
  * Document patches in DEP3 headers .
  * Prevent installation of upstream-provided license.htm instead of deleting
    it.

 -- Etienne Millon <etienne.millon@gmail.com>  Mon, 04 Apr 2011 12:07:05 +0200

zsnes (1.510-3) unstable; urgency=low

  * New maintainer (Closes: #573418).
    - This package is now maintained by the Debian Games Team.
    - Add Eshat Cakar and myself to Uploaders.
  * Remove useless build-deps on xlibmesa-gl-dev and xutils (Closes: #579040).
  * Add support for amd64 (Closes: #402104)
  * debian/control: clarifiy description thanks to Ubuntu patch
    (Closes: #487118)
  * Add ${misc:Depends} to dependencies.
  * Add debian/watch file.
  * Switched to '3.0 (quilt)' format.
  * Bump Standards-Version to 3.9.1 (no changes).
  * zsnes.desktop: removed useless Encoding field.
  * zsnes.doc-base: removed 'Apps/' prefix from Section.
  * Build know copies config.{guess,sub} from autotools-dev.
  * Add patches to upstream sources:
    - Convert the manpage to use minus signs and en-dashes instead of hyphens.
    - Correct a spelling error.
    - Remove an extra license file in documentation.

 -- Etienne Millon <etienne.millon@gmail.com>  Wed, 01 Dec 2010 16:55:26 +0100

zsnes (1.510-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix the debian/rules clean problem, with a patch courtesy of
    Gunnar Wolf <gwolf@gwolf.org> (closes: #513205)
  * Urgency medium to fix RC bug in testing

 -- Vincent Fourmond <fourmond@debian.org>  Tue, 03 Feb 2009 21:52:28 +0100

zsnes (1.510-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Fix gcc-4.3 FTBFS (Closes: #474804).

 -- Ian Beckwith <ianb@erislabs.net>  Thu, 10 Apr 2008 22:20:59 +0100

zsnes (1.510-2) unstable; urgency=low

  * Acknowledge NMU, closes: #447366
  * Fix build failure with g++ 4.2, closes: #459033
  * Bump Standards-Version to 3.7.3
  * Move menu file from Apps to Applications. I think this closes: #443789.

 -- Joshua Kwan <joshk@triplehelix.org>  Thu, 10 Jan 2008 20:49:18 -0800

zsnes (1.510-1.1) unstable; urgency=low

  * Non-maintainer upload to fix RC bug.
  * Fix FTBFS, CRC32 is now a keyword in nasm, replace it by RomCRC32.
    Patch by Javier Serrano Polo <jasp00@terra.es>. (Closes: #447366)



=== debian/control ===
Source: zsnes
Section: otherosfs
Priority: optional
Homepage: http://www.zsnes.com
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Etienne Millon <etienne.millon@gmail.com>,
           Eshat Cakar <info@eshat.de>,
           Fabian Greffrath <fabian+debian@greffrath.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               dpkg-dev (>= 1.13.2),
               libgl1-mesa-dev | libgl-dev,
               libncurses5-dev | libncurses-dev,
               libpng-dev,
               libsdl1.2-dev (>= 1.2.2-3.1),
               nasm,
               sharutils,
               zlib1g-dev
Standards-Version: 3.9.4
Vcs-Git: git://anonscm.debian.org/pkg-games/zsnes.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/zsnes.git

Package: zsnes
Architecture: any-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Emulator of the Super Nintendo Entertainment System
 ZSNES allows you to play classic games written for the Super Nintendo (SNES)
 game console on a GNU/Linux system.
 .
 Please note that many separately-available games playable under this
 emulator are non-free. See /usr/share/doc/zsnes/README.Debian for more
 information.

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,6 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 #export DH_OPTIONS=-v
-
-DPKG_EXPORT_BUILDFLAGS=1
-include /usr/share/dpkg/buildflags.mk
 
 CFLAGS   += $(CPPFLAGS)
 CXXFLAGS += $(CPPFLAGS)
@@ -66,6 +63,3 @@
 
 override_dh_compress:
 	dh_compress -Xdeb.set
-
-override_dh_strip:
-	dh_strip --dbgsym-migration='zsnes-dbg (<< 1.510+bz2-9~)'
